compute progname = 'enso.prg'
com numobs = 168
com numparams = 9
all numobs
open data enso.prn
data(for=prn,org=obs)

nonlin b1 b2 b3 b4 b5 b6 b7 b8 b9

frml f y = b1 + $
                b2*cos(2*%pi*x/12.0) + b3*sin(2*%pi*x/12.0) + $
                b5*cos(2*%pi*x/b4)   + b6*sin(2*%pi*x/b4)   + $
                b8*cos(2*%pi*x/b7)   + b9*sin(2*%pi*x/b7)

dec rect b(numparams,4)
input(unit=input) b
   11.0        10.0          1.0510749193E+01  1.7488832467E-01
    3.0         3.0          3.0762128085E+00  2.4310052139E-01
    0.5         0.5          5.3280138227E-01  2.4354686618E-01
   40.0        44.0          4.4311088700E+01  9.4408025976E-01
   -0.7        -1.5         -1.6231428586E+00  2.8078369611E-01
   -1.3         0.5          5.2554493756E-01  4.8073701119E-01
   25.0        26.0          2.6887614440E+01  4.1612939130E-01
   -0.3        -0.1          2.1232288488E-01  5.1460022911E-01
    1.4         1.5          1.4966870418E+00  2.5434468893E-01


* Start 1:
com i=1,startval=1
compute b1=b(1,i),b2=b(2,i),b3=b(3,i),b4=b(4,i),b5=b(5,i),b6=b(6,i),b7=b(7,i),b8=b(8,i),b9=b(9,i)
dis b1 b2 b3 b4 b5 b6 b7 b8
nlls(frml=f,notrace,cvcrit=1e-11,iter=200)

dec rec[real] beta_std(numparams,1)
do i=1,numparams
 com beta_std(i,1) = sqrt(%seesq*%xx(i,i))
end do i

source(noecho) output.prg


* Start 2:
com i=2,startval=2
compute b1=b(1,i),b2=b(2,i),b3=b(3,i),b4=b(4,i),b5=b(5,i),b6=b(6,i),b7=b(7,i),b8=b(8,i),b9=b(9,i)
dis b1 b2 b3 b4 b5 b6 b7 b8 b9
nlls(frml=f,notrace,cvcrit=1e-11,iters=200) y

dec rec[real] beta_std(numparams,1)
do i=1,numparams
 com beta_std(i,1) = sqrt(%seesq*%xx(i,i))
end do i
com r2 = %rsquared

source(noecho) output.prg



* Start 3:
com i=3,startval=3
compute b1=b(1,i),b2=b(2,i),b3=b(3,i),b4=b(4,i),b5=b(5,i),b6=b(6,i),b7=b(7,i),b8=b(8,i),b9=b(9,i)
dis b1 b2 b3 b4 b5 b6 b7 b8 b9
nlls(frml=f,notrace,cvcrit=1e-11,iters=200) y

dec rec[real] beta_std(numparams,1)
do i=1,numparams
 com beta_std(i,1) = sqrt(%seesq*%xx(i,i))
end do i
com r2 = %rsquared

source(noecho) output.prg




