compute progname = 'hahn1.prg'
dis 'NLPAR limit raised to 1000'
nlpar(subit=100)
display 'This program produces bad results with original data'
display 'Simple re-scaling fixes the problem for the "Start 1" values, as noted below'
com numobs = 236
com numparams = 7
all numobs
open data hahn1.prn
data(for=prn,org=obs)
set xtemp = x
table
nonlin b1 b2 b3 b4 b5 b6 b7
frml f y = (b1 + b2*x + b3*x**2 + b4*x**3) / (1 + b5*x + b6*x**2 + b7*x**3)

dec rect b(numparams,4)
input(unit=input) b
   10          1            1.0776351733E+00  1.7070154742E-01
   -1          -0.1         -1.2269296921E-01  1.2000289189E-02
    0.05        0.005        4.0863750610E-03  2.2508314937E-04
   -0.00001    -0.000001    -1.4262662514E-06  2.7578037666E-07
   -0.05       -0.005       -5.7609940901E-03  2.4712888219E-04
    0.001       0.0001       2.4053735503E-04  1.0449373768E-05
   -0.000001   -0.0000001   -1.2314450199E-07  1.3027335327E-08

dis 'Start 1:'
com i=1,startval=1
compute b1=b(1,i),b2=b(2,i),b3=b(3,i),b4=b(4,i),b5=b(5,i),b6=b(6,i),b7=b(7,i)
dis b1 b2 b3 b4 b5 b6 b7
nlls(frml=f,notrace,cvcrit=1e-11,iter=200)

dec rec[real] beta_std(numparams,1)
do i=1,numparams
 com beta_std(i,1) = sqrt(%seesq*%xx(i,i))
end do i

source(noecho) output.prg


dis 'Start 2:'
com i=2,startval=2
compute b1=b(1,i),b2=b(2,i),b3=b(3,i),b4=b(4,i),b5=b(5,i),b6=b(6,i),b7=b(7,i)
nlls(frml=f,notrace,cvcrit=1e-11,iter=200)

dec rec[real] beta_std(numparams,1)
do i=1,numparams
 com beta_std(i,1) = sqrt(%seesq*%xx(i,i))
end do i
source(noecho) output.prg

dis 'Start 3:'
com i=3,startval=3
compute b1=b(1,i),b2=b(2,i),b3=b(3,i),b4=b(4,i),b5=b(5,i),b6=b(6,i),b7=b(7,i)
nlls(frml=f,notrace,cvcrit=1e-11,iter=200)

dec rec[real] beta_std(numparams,1)
do i=1,numparams
 com beta_std(i,1) = sqrt(%seesq*%xx(i,i))
end do i
source(noecho) output.prg

dis 'Start 4'
Display 'scaling x by 1/100, using Start 1 values:'
set x = xtemp
set x = x * .01
table
com i=1,startval=1
compute b1=b(1,i),b2=b(2,i),b3=b(3,i),b4=b(4,i),b5=b(5,i),b6=b(6,i),b7=b(7,i)
dis b1 b2 b3 b4 b5 b6 b7
nlls(frml=f,notrace,cvcrit=1e-11,iter=200)

dec rec[real] beta_std(numparams,1)
do i=1,numparams
 com beta_std(i,1) = sqrt(%seesq*%xx(i,i))
end do i

display 'For comparison purpose, need to apply appropriate re-scaling'
display ' for each parameter. Here, we re-scale the "target" values:'

do i=1,7
 compute b(i,3) = %if(i<5 , b(i,3)*10**(2*(i-1))  , b(i,3)*10**(2*(i-4)) )
 compute b(i,4) = %if(i<5 , b(i,4)*10**(2*(i-1))  , b(i,4)*10**(2*(i-4)) )
end do i

source(noecho) output.prg




