compute progname = 'kirby2.prg'
dis 'Marginal results given original values, but'
dis ' a simple rescaling gives about double the '
dis ' accuracy (see Start 3 and Start 4)'
dis
dis 'Slight additional improvement using tighter'
dis ' convergence criteria (Start 5)'
dis

com numobs = 151
com numparams = 5
all numobs
open data kirby2.prn
data(for=prn,org=obs)

nonlin b1 b2 b3 b4 b5

frml f y = (b1 + b2*x + b3*x**2) / ( 1 + b4*x + b5*x**2)

dec rect b(numparams,4)
input(unit=input) b
    2           1.5          1.6745063063E+00  8.7989634338E-02
   -0.1        -0.15        -1.3927397867E-01  4.1182041386E-03
    0.003       0.0025       2.5961181191E-03  4.1856520458E-05
   -0.001      -0.0015      -1.7241811870E-03  5.8931897355E-05
    0.00001     0.00002      2.1664802578E-05  2.0129761919E-07

display 'Start 1:'
com i=1,startval=1
compute b1=b(1,i),b2=b(2,i),b3=b(3,i),b4=b(4,i),b5=b(5,i)
dis b1 b2 b3 b4 b5
nlls(frml=f,notrace,cvcrit=1e-11,iter=200)

dec rec[real] beta_std(numparams,1)
do i=1,numparams
 com beta_std(i,1) = sqrt(%seesq*%xx(i,i))
end do i

source(noecho) output.prg



dis 'Start 2:'
com i=2,startval=2
compute b1=b(1,i),b2=b(2,i),b3=b(3,i),b4=b(4,i),b5=b(5,i)
dis b1 b2 b3 b4 b5
nlls(frml=f,notrace,cvcrit=1e-11,iter=200)

dec rec[real] beta_std(numparams,1)
do i=1,numparams
 com beta_std(i,1) = sqrt(%seesq*%xx(i,i))
end do i

source(noecho) output.prg

dis 'Start 3:'
com i=3,startval=3
compute b1=b(1,i),b2=b(2,i),b3=b(3,i),b4=b(4,i),b5=b(5,i)
dis b1 b2 b3 b4 b5
nlls(frml=f,notrace,cvcrit=1e-11,iter=200)

dec rec[real] beta_std(numparams,1)
do i=1,numparams
 com beta_std(i,1) = sqrt(%seesq*%xx(i,i))
end do i

source(noecho) output.prg



dis 'Start 4:'
* Rescale
set x = .01*x
do i=1,4
 com b(2,i) = b(2,i)*10**2, b(3,i) = b(3,i)*10**4, b(4,i) = b(4,i)*10**2, b(5,i) = b(5,i)*10**4
end do 4
write b

com i=1,startval=1
compute b1=b(1,i),b2=b(2,i),b3=b(3,i),b4=b(4,i),b5=b(5,i)
nlls(frml=f,notrace,cvcrit=1e-11,iter=200)

dec rec[real] beta_std(numparams,1)
do i=1,numparams
 com beta_std(i,1) = sqrt(%seesq*%xx(i,i))
end do i

source(noecho) output.prg


dis 'Start 5:'
com i=2,startval=2
compute b1=b(1,i),b2=b(2,i),b3=b(3,i),b4=b(4,i),b5=b(5,i)
nlls(frml=f,notrace,cvcrit=1e-11,iter=200)

dec rec[real] beta_std(numparams,1)
do i=1,numparams
 com beta_std(i,1) = sqrt(%seesq*%xx(i,i))
end do i

source(noecho) output.prg


dis 'Start 6:'
dis 'Using tighter criteria, setting subit limit to 500'
nlpar(cvcrit=.00000000001,subiter=500)
com i=2
compute b1=b(1,i),b2=b(2,i),b3=b(3,i),b4=b(4,i),b5=b(5,i)
nlls(frml=f,notrace,cvcrit=1e-11,iter=200)

dec rec[real] beta_std(numparams,1)
do i=1,numparams
 com beta_std(i,1) = sqrt(%seesq*%xx(i,i))
end do i

source(noecho) output.prg






